# PHTTPField Class Reference

This class is the abstract base class for fields in a `PHTTPForm` resource type. More...

`#include <httpform.h>`

Inheritance diagram for PHTTPField:

List of all members.

## Public Member Functions

| PHTTPField (const char *bname, const char *title, const char *help)
virtual Comparison | Compare (const PObject &obj) const
| Compare the fields using the field names.
const PCaselessString & | GetName () const
| Get the identifier name of the field.
const PCaselessString & | GetBaseName () const
| Get the identifier name of the field.
virtual void | SetName (const PString &newName)
| Set the name for the field.
virtual const PHTTPField * | LocateName (const PString &name) const
| Locate the field naem, recusing down for composite fields.
const PString & | GetTitle () const
| Get the title of the field.
const PString & | GetHelp () const
| Get the title of the field.
void | SetHelp (const PString &text)
void | SetHelp (const PString &hotLinkURL, const PString &linkText)
void | SetHelp (const PString &hotLinkURL, const PString &imageURL, const PString &imageText)
virtual PHTTPField * | NewField () const =0
| Create a new field of the same class as the current field.
virtual void | ExpandFieldNames (PString &text, PINDEX start, PINDEX &finish) const
virtual void | GetHTMLTag (PHTML &html) const =0
| Convert the field to HTML form tag for inclusion into the HTTP page.
virtual PString | GetHTMLInput (const PString &input) const
| Convert the field input to HTML for inclusion into the HTTP page.
virtual PString | GetHTMLSelect (const PString &selection) const
| Convert the field input to HTML for inclusion into the HTTP page.
virtual void | GetHTMLHeading (PHTML &html) const
| Convert the field to HTML for inclusion into the HTTP page.
virtual PString | GetValue (PBoolean dflt=false) const =0
| Get the string value of the field.
virtual void | SetValue (const PString &newValue)=0
| Set the value of the field.
virtual void | LoadFromConfig (PConfig &cfg)
| Get the value of the PConfig to the sub-field.
virtual void | SaveToConfig (PConfig &cfg) const
| Set the value of the sub-field into the PConfig.
virtual PBoolean | Validated (const PString &newVal, PStringStream &msg) const
| Validate the new field value before `SetValue()` is called.
virtual void | GetAllNames (PStringArray &names) const
| Retrieve all the names in the field and subfields.
virtual void | SetAllValues (const PStringToString &data)
| Set the value of the field in a list of fields.
virtual PBoolean | ValidateAll (const PStringToString &data, PStringStream &msg) const
| Validate the new field value in a list before `SetValue()` is called.
PBoolean | NotYetInHTML () const
void | SetInHTML ()

## Protected Attributes

PCaselessString | baseName
PCaselessString | fullName
PString | title
PString | help
PBoolean | notInHTML

## Detailed Description

This class is the abstract base class for fields in a `PHTTPForm` resource type.

## Constructor & Destructor Documentation

PHTTPField::PHTTPField | ( | const char * | bname,
|  | const char * | title,
|  | const char * | help |
| ) |  |  |

## Member Function Documentation

virtual Comparison PHTTPField::Compare | ( | const PObject & | obj | ) | const`[virtual]`

Compare the fields using the field names.

Returns:
  Comparison of the name fields of the two fields.

Reimplemented from PObject.

virtual void PHTTPField::ExpandFieldNames | ( | PString & | text,
|  | PINDEX | start,
|  | PINDEX & | finish |
| ) |  |  | const`[virtual]`

Reimplemented in PHTTPCompositeField, and PHTTPFieldArray.

virtual void PHTTPField::GetAllNames | ( | PStringArray & | names | ) | const`[virtual]`

Retrieve all the names in the field and subfields.

Returns:
  Array of strings for each subfield.

Reimplemented in PHTTPCompositeField.

const PCaselessString& PHTTPField::GetBaseName | ( |  | ) | const`[inline]`

Get the identifier name of the field.

Returns:
  String for field name.

const PString& PHTTPField::GetHelp | ( |  | ) | const`[inline]`

Get the title of the field.

Returns:
  String for title placed next to the field.

virtual void PHTTPField::GetHTMLHeading | ( | PHTML & | html | ) | const`[virtual]`

Convert the field to HTML for inclusion into the HTTP page.

Reimplemented in PHTTPCompositeField, and PHTTPSubForm.

virtual PString PHTTPField::GetHTMLInput | ( | const PString & | input | ) | const`[virtual]`

Convert the field input to HTML for inclusion into the HTTP page.

Reimplemented in PHTTPCompositeField, PHTTPBooleanField, and PHTTPRadioField.

virtual PString PHTTPField::GetHTMLSelect | ( | const PString & | selection | ) | const`[virtual]`

Convert the field input to HTML for inclusion into the HTTP page.

virtual void PHTTPField::GetHTMLTag | ( | PHTML & | html | ) | const`[pure virtual]`

Convert the field to HTML form tag for inclusion into the HTTP page.

Implemented in PHTTPCompositeField, PHTTPSubForm, PHTTPFieldArray, PHTTPStringField, PHTTPPasswordField, PHTTPIntegerField, PHTTPBooleanField, PHTTPRadioField, and PHTTPSelectField.

const PCaselessString& PHTTPField::GetName | ( |  | ) | const`[inline]`

Get the identifier name of the field.

Returns:
  String for field name.

const PString& PHTTPField::GetTitle | ( |  | ) | const`[inline]`

Get the title of the field.

Returns:
  String for title placed next to the field.

virtual PString PHTTPField::GetValue | ( | PBoolean | dflt = `false` | ) | const`[pure virtual]`

Get the string value of the field.

Returns:
  String for field value.

Implemented in PHTTPCompositeField, PHTTPStringField, PHTTPPasswordField, PHTTPIntegerField, PHTTPBooleanField, PHTTPRadioField, and PHTTPSelectField.

virtual void PHTTPField::LoadFromConfig | ( | PConfig & | cfg | ) | `[virtual]`

Get the value of the PConfig to the sub-field.

If the field is not composite then it always sets the value as for the non-indexed version.

Reimplemented in PHTTPCompositeField, PHTTPFieldArray, PHTTPIntegerField, and PHTTPBooleanField.

virtual const PHTTPField* PHTTPField::LocateName | ( | const PString & | name | ) | const`[virtual]`

Locate the field naem, recusing down for composite fields.

Returns:
  Pointer to located field, or NULL if not found.

Reimplemented in PHTTPCompositeField.

virtual PHTTPField* PHTTPField::NewField | ( |  | ) | const`[pure virtual]`

Create a new field of the same class as the current field.

Returns:
  New field object instance.

Implemented in PHTTPCompositeField, PHTTPSubForm, PHTTPFieldArray, PHTTPStringField, PHTTPPasswordField, PHTTPDateField, PHTTPIntegerField, PHTTPBooleanField, PHTTPRadioField, and PHTTPSelectField.

PBoolean PHTTPField::NotYetInHTML | ( |  | ) | const`[inline]`

virtual void PHTTPField::SaveToConfig | ( | PConfig & | cfg | ) | const`[virtual]`

Set the value of the sub-field into the PConfig.

If the field is not composite then it always sets the value as for the non-indexed version.

Reimplemented in PHTTPCompositeField, PHTTPFieldArray, PHTTPIntegerField, and PHTTPBooleanField.

virtual void PHTTPField::SetAllValues | ( | const PStringToString & | data | ) | `[virtual]`

Set the value of the field in a list of fields.

Reimplemented in PHTTPCompositeField, and PHTTPFieldArray.

void PHTTPField::SetHelp | ( | const PString & | hotLinkURL,
|  | const PString & | imageURL,
|  | const PString & | imageText |
| ) |  |  |

void PHTTPField::SetHelp | ( | const PString & | hotLinkURL,
|  | const PString & | linkText |
| ) |  |  |

void PHTTPField::SetHelp | ( | const PString & | text | ) | `[inline]`

void PHTTPField::SetInHTML | ( |  | ) | `[inline]`

virtual void PHTTPField::SetName | ( | const PString & | newName | ) | `[virtual]`

Set the name for the field.

Reimplemented in PHTTPCompositeField.

virtual void PHTTPField::SetValue | ( | const PString & | newValue | ) | `[pure virtual]`

Set the value of the field.

Implemented in PHTTPCompositeField, PHTTPStringField, PHTTPPasswordField, PHTTPDateField, PHTTPIntegerField, PHTTPBooleanField, PHTTPRadioField, and PHTTPSelectField.

virtual PBoolean PHTTPField::ValidateAll | ( | const PStringToString & | data,
|  | PStringStream & | msg |
| ) |  |  | const`[virtual]`

Validate the new field value in a list before `SetValue()` is called.

Returns:
  PBoolean if the all the new field values are OK.

Reimplemented in PHTTPCompositeField.

virtual PBoolean PHTTPField::Validated | ( | const PString & | newVal,
|  | PStringStream & | msg |
| ) |  |  | const`[virtual]`

Validate the new field value before `SetValue()` is called.

Returns:
  PBoolean if the new field value is OK.

Reimplemented in PHTTPDateField, and PHTTPIntegerField.

## Member Data Documentation

PCaselessString PHTTPField::baseName `[protected]`

PCaselessString PHTTPField::fullName `[protected]`

PString PHTTPField::help `[protected]`

PBoolean PHTTPField::notInHTML `[protected]`

PString PHTTPField::title `[protected]`

The documentation for this class was generated from the following file:

- httpform.h